//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// PlayGui is the main TSControl through which the game is viewed.
// The PlayGui also contains the hud controls.
//-----------------------------------------------------------------------------

function PlayGui::onWake(%this)
{
   // Turn off any shell sounds...
   // alxStop( ... );

   $enableDirectInput = "1";
   activateDirectInput();

   // Message hud dialog
   Canvas.pushDialog( MainChatHud );
   chatHud.attach(HudMessageVector);

   // just update the action map here
   moveMap.push();
   
   // hack city - these controls are floating around and need to be clamped
   schedule(0, 0, "refreshCenterTextCtrl");
   schedule(0, 0, "refreshBottomTextCtrl");
   setFPSvis();
}

function PlayGui::onSleep(%this)
{
   Canvas.popDialog( MainChatHud  );
   
   // pop the keymaps
   moveMap.pop();
}


//-----------------------------------------------------------------------------

function refreshBottomTextCtrl()
{
   BottomPrintText.position = "0 0";
}

function refreshCenterTextCtrl()
{
   CenterPrintText.position = "0 0";
}
$ChTotal = 0;
function getcrosshaircount() {
    %file_path = "tbm/client/ui/crosshairs/*.png";
    for(%file_name = findFirstFile(%file_path); %file_name !$= ""; %file_name = findNextFile(%file_path))
        $Crosshair[$ChTotal++] = %file_name;
}
getcrosshaircount();
function crosshairswitch(){
$pref::crosshair++;
if($pref::crosshair > $ChTotal)
$pref::crosshair = 1;
HudCrosshair.setBitmap($Crosshair[$pref::crosshair]);
}
cancel($fpsHUD);
function getFPS() {
FPS_txt.setText("\c3"@$FPS::real);
$fpsHUD = schedule(1000,0,getfps);
}
getfps();

function ep() {
exec("tbm/client/scripts/playgui.cs");
}

function setFPSvis() {
   if($Pref::Gui::ShowFPS)
   FPS_HUD.setVisible(1);
   else
   FPS_HUD.setVisible(0);
}
