$vehicleexp=60000;
function findEmptySeat(%vehicle)
{
	for (%i = 0; %i <  %vehicle.getDataBlock().numMountPoints; %i++)
		if(%vehicle.getMountNodeObject(%i) == 0)
			return %i;
	return -1;
}

function onMountVehicle(%vehicle, %player)
{
	if (!%vehicle.mountable)
		return;
	%seat = findEmptySeat(%vehicle);

	if(%seat > -1)
	{
		%player.isMounted = true;
		%player.mVehicle = %vehicle;
		%player.mSeat = %seat;
		%vehicle.mountObject(%player,%seat);
		%player.playThread(3,%vehicle.getDatablock().mountPose[%seat]);
		if(%seat == 0)
			%player.setControlObject(%vehicle);
		else
			%player.setControlObject(%player);
		if(%vehicle.expire_timer)
			%vehicle.expire_timer.cancel();
	}
}

function doPlayerDismount(%client)
{
	%player = %client.player;
	%vehicle = %player.mVehicle;
	if(!%player.isMounted || !%vehicle)
		return;

	%pos = getWords(%player.getTransform(), 0, 2);

	%player.mountVehicle = false;
	%player.isMounted = false;
	%player.schedule(4000, "setMountVehicle", true);
	%player.schedule(4000, "mountVehicles", true);

	%player.unmount();
	%player.setControlObject(%player);
	%player.playThread(3, root);

	%player.setTransform(%pos);
	%player.setVelocity(vectorAdd(vectorScale(%vehicle.getVelocity(), 0.75), "0 0 10"));
	if(%vehicle.getMountNodeObject(%player.mSeat+1))
			setActiveSeat(%vehicle.getMountNodeObject(%player.mSeat+1), %vehicle, %player.mSeat);
	%vehicle.mountable = true;
	%vehicle.expire_timer = schedule($vehicleexp, 0, vehicleExpired, %vehicle);
}

function setActiveSeat(%player, %vehicle, %seat)
{
	if(%player.isMounted)
		%player.unMount();
	%vehicle.mountObject(%player,%seat);
	%player.mVehicle = %vehicle;
	%player.mSeat = %seat;

	%player.playThread(0,%vehicle.getDatablock().mountPose[%seat]);

	if (%seat == 0)
	{
		%player.setControlObject(%vehicle);
		messageClient(%player.client, 'junk', "You now control this vehicle!");
	}
	else
		%player.setControlObject(%player);
	if(%vehicle.getMountNodeObject(%player.mSeat+2))
		setActiveSeat(%vehicle.getMountNodeObject(%player.mSeat+2), %vehicle, %player.mSeat+1);
}

function serverCmdMountVehicle(%client)
{
	if(%scanTarg = getWord(ContainerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 3), %client.player.getEyePoint()), $TypeMasks::vehicleObjectType), 0))
		onMountVehicle(%scanTarg,%client.player);
	else
		doPlayerDismount(%client);
}

function vehicleExpired(%vehicle)
{
	for (%i = 0; %i <  %vehicle.getDataBlock().numMountPoints; %i++)
		if(%vehicle.getMountNodeObject(%i))
			return;
	%vehicle.startFade(1000,0,true);
	%vehicle.schedule(1000, delete);
}